/************************************************
 * Program pro AT90S2313,8MHz                   *
 * DS18B20 pipojen na pin PD0			*					        *
 * Vstup na LCD 2x16 znak:			*
 * RS - PD1					*
 * E  - PD2					*
 * D4 - PD3					*
 * D5 - PD4					*
 * D6 - PD5					*
 * D7 - PD6					*
 ************************************************
*/

#include <avr/io.h>
#define F_CPU 8000000UL
#include <util/delay.h>
#include "LCD.h"
#include "OneWire.h"

//=========================== Definice promnnch
unsigned int setiny;
unsigned int temp;
unsigned int teplota;
unsigned char Posun_bit;

//  Zadej hodnotu Rozlis_bit dle typu idla
//  18S20: 9  (zkladn nstaven; vbr 9,10,11,nebo 12)
//  18B20: 12

const unsigned char Rozlis_bit = 12;	//idlo DS18B20, 12bit

char *text ="000.00";

//=========================== Hlavn program
int main()
{
	_delay_ms(500);
			
	Lcd_Init();			//Inicializace LCD displeje
	Lcd_Cmd(0x01);		//Clear
	Lcd_Cmd(0x02);		//Home

//=========================== Nekonen smyka	
  while(1)
   {
   	
//Nastaven pevodu idla
	Ow_Reset(&PORTD,0);
	Ow_Write(&PORTD,0,0xCC);	//Pesko ten ROM
	Ow_Write(&PORTD,0,0x44);	//Zahjen pevodu

	_delay_ms(400);				//Doba pevodu

	unsigned char a1;
	unsigned char scratchpad[2];
	for(a1=0;a1<2;a1++) scratchpad[a1] = 0;

	Ow_Reset(&PORTD,0);
	Ow_Write(&PORTD,0,0xCC);	//Pesko ten ROM
	Ow_Write(&PORTD,0,0xBE);	//ten z scratchpadu

//Naten obsahu adres scratchpadu do a0 - a1	
	for(a1=0;a1<2;a1++)
		scratchpad[a1]=Ow_Read(&PORTD,0);

	teplota = scratchpad[1]<<8|scratchpad[0];

	Posun_bit = Rozlis_bit - 8;
	temp = teplota >> Posun_bit;
			

	if(PRESEN == 1)		//Pokrauj pokud idlo pipojeno
	 {
		Lcd_Out(1,1,"DS18B20:");

		if (temp/100)
		 {
    		  text[0] = temp/100  + 48; //Vpoet stovek
		 }
  		else
		 {
    		 text[0] = ' ';            //Nezobrazen nuly na zatku
		 }
							  
		text[1] = (temp/10) + 48 ;	  //Vpoet desitek
		text[2] = (temp%10) + 48 ;	  //Vpoet jednotek

		temp = teplota << (4 - Posun_bit);

//Vpoet setin
 		setiny = temp & 0x000F; 
		setiny = setiny * 625;

//Zobrazen "-" pi teplot < 0C
		if(teplota & 0x8000)
		 text[0] = '-';
	
//vpoet pro zobrazen setin
  		text[4] =  setiny/1000    + 48;    //vpoet desetin    
  		text[5] = (setiny/100)%10 + 48;    //Vpoet setin     
	        
		Lcd_Out(1,9,text);
		Lcd_Znak(0xDF);		//Zobrazen 
		Lcd_Znak(0x43);		//Zobrazen C

      }
	 else
		Lcd_Out(1,1,"DS18B20 = Error");	//idlo nezapojeno

  }

}
