/* LCD.h */
#ifndef _LCD_H__
#define _LCD_H__

#define LCD_P PORTD
#define LCD_R DDRD

#define LCD_RS 1
#define LCD_E 2
#define LCD_D4 3
#define LCD_D5 4
#define LCD_D6 5
#define LCD_D7 6 

//Pkaz
void Lcd_Cmd(unsigned char Znak)
{

/*
Ped zapsnm horn poloviny byte na port
je nutn vzhledem k zapojen
LCD - PORT, posunout data o 1 msto vpravo
Pi jinm zapojen je nutn prava
*/

 LCD_P = ((Znak & 0b11110000)>>1); //horn pl byte
 LCD_P&=~(1<<LCD_RS);	//RS = 0(pkaz)	
 LCD_P|=1<<LCD_E;		//E = 0
 _delay_us(100);		//ustlen dat
 LCD_P&=~(1<<LCD_E);	//E = 0(zpis)
 _delay_us(100);

/*
Ped zapsnm doln poloviny byte na port
je nutn vhledem k zapojen
LCD - PORT, posunout data o 3 msta vlevo
Pi jinm zapojen je nutn prava
*/

 LCD_P=((Znak & 0b00001111)<<3); //doln pl byte
 LCD_P&=~(1<<LCD_RS);	//RS = 0(pkaz)	
 LCD_P|=1<<LCD_E;		//E = 0
 _delay_us(100);
 LCD_P&=~(1<<LCD_E);	//E = 1(zpis)

/*
Pokud je vsledek v podmnce nula, jedn se o 
pkaz "Vyma dislej" nebo "Nvrat na zatek", kter
vyaduj del interval
*/
 if ((Znak & 0b111111100) > 0)
  {
  	_delay_us(100);
  }
  else
  {
	_delay_ms(2);	//ekej > 1,64ms
  }
 } 

//Znak
void Lcd_Znak(unsigned char Znak)
{
 LCD_P = ((Znak & 0b11110000)>>1);
 LCD_P|=(1<<LCD_RS);	//RS = 1(data)
 LCD_P|=(1<<LCD_E);		//E = 1
 _delay_us(100);		//ustlen dat
 LCD_P&=~(1<<LCD_E);	//E = 0(zpis)
 _delay_us(100);

 LCD_P=((Znak & 0b00001111)<<3);
 LCD_P|=(1<<LCD_RS);	//RS = 1(data)
 LCD_P|=(1<<LCD_E);		//E = 0
 _delay_us(100);		//ustlen dat
 LCD_P&=~(1<<LCD_E);	//E = 0(zpis)
 _delay_us(100);
}

//inicializace LCD
void Lcd_Init(void)
{
 _delay_ms(15);	//ekej 15ms
 LCD_P=0x00;

//Nastav PORT na vstup	
 LCD_R|=(1<<LCD_D7|1<<LCD_D6|1<<LCD_D5|1<<LCD_D4);
 LCD_R|=(1<<LCD_E|1<<LCD_RS);

//zapi 03h
 LCD_P=(0<<LCD_D7|0<<LCD_D6|1<<LCD_D5|1<<LCD_D4); 
 LCD_P|=(1<<LCD_E|0<<LCD_RS); //E = 1,RS = 0
 _delay_us(100);		      //ustlen dat
 LCD_P&=~(1<<LCD_E);	      //E = 0(zpis)
 _delay_ms(5);	              //ekej > 4,1ms

//zapi 03h
 LCD_P=(0<<LCD_D7|0<<LCD_D6|1<<LCD_D5|1<<LCD_D4); 
 LCD_P|=(1<<LCD_E|0<<LCD_RS); //E = 1,RS = 0
 _delay_us(100);		      //ustlen dat
 LCD_P&=~(1<<LCD_E);	      //E = 0(zpis)
 _delay_us(100);			  

//zapi 03h
 LCD_P=(0<<LCD_D7|0<<LCD_D6|1<<LCD_D5|1<<LCD_D4); 
 LCD_P|=(1<<LCD_E|0<<LCD_RS); //E = 1,RS = 0
 _delay_us(100);		      //ustlen dat
 LCD_P&=~(1<<LCD_E);	      //E = 0(zpis)
 _delay_us(100);
 
//4bitov komunikace
LCD_P=(0<<LCD_D7|0<<LCD_D6|1<<LCD_D5|0<<LCD_D4); 
 LCD_P|=(1<<LCD_E|0<<LCD_RS); //E = 1,RS = 0
 _delay_us(100);		      //ustlen dat
 LCD_P&=~(1<<LCD_E);	      //E = 0(zpis)
 _delay_us(100);

 Lcd_Cmd(0b00101000);		  //dva dky
 Lcd_Cmd(0b00000001);		  //sma LCD
 Lcd_Cmd(0b00001100);		  //zapni LCD
 Lcd_Cmd(0b00000110);		  //incrementace
}

//Vpis textu na pozici x,y
void Lcd_Out(unsigned char x, unsigned char y, char* str)
{
  if(x==2)
	{
	 x=0x40;
	}
	else
	{
	 x=0x00;
	}
  y--;
  Lcd_Cmd(0b10000000 | x | y);

 x = 0;
 while(str[x]!=0)
  {
	_delay_ms(1);
	Lcd_Znak(str[x]);
	x++;
  }
}

//Vpis znaku na pozici x,y
void Lcd_Chr(unsigned char x, unsigned char y,char str)
{
  if(x==2)
	{
	 x=0x40;	//adresa druhho dku
	}
	else
	{
	 x=0x00;	
	}
  y--;

  Lcd_Cmd(0b10000000 | x | y);
  Lcd_Znak(str);
}
#endif