/*
 Komunikace s obvodem DALLAS DS18B20
Pro tuto komunikaci jsou pouvny pkazy:

Ow_Reset(&PORT,PIN)
Ow_Write(&PORT,PIN,DATA)
DATA = Ow_Read(&PORT,PIN)  
*/

#ifndef _OneWire_H_
#define _OneWire_H_

volatile unsigned char PRESEN;

//Komunikace s obvody DALLAS

//Pkaz reset
void Ow_Reset(volatile unsigned char *pPort,unsigned char DQ)
{
	*(pPort)&=~(1<<DQ);
	*(pPort-1)|=1<<DQ;			
	_delay_us(480);	
				
	*(pPort-1)&=~(1<<DQ);	
	_delay_us(65);

	PRESEN = 0;
//Pokud je pipojeno idlo PRESEN = 1
	
	if((*(pPort-2)&(1<<DQ)) == 0)
		{
			PRESEN = 1;	
		}
	_delay_us(480);
}

//Read byte
int Ow_Read(volatile unsigned char *pPort,unsigned char DQ)
{
unsigned char i;
unsigned char byte; 
byte = 0;
	for(i=0;i<8;i++)
	 {
		*(pPort)&=~(1<<DQ);			
		*(pPort-1)|=1<<DQ;				
		_delay_us(5);
			
		*(pPort-1)&=~(1<<DQ);		
		_delay_us(10);

	 		if((*(pPort-2)&(1<<DQ))>0)
			 {
				byte|=1<<i;		
			 }
		_delay_us(55);
	 }
	 return byte;
}

// Write byte
void Ow_Write(volatile unsigned char *pPort,unsigned char DQ,unsigned char byte)
{
unsigned char i;
	for(i=0;i<8;i++)
	 {
		if((byte&(1<<i)) > 0)
		 {
	          *(pPort)&=~(1<<DQ);			
		  *(pPort-1)|=1<<DQ;					  	
		  _delay_us(5);

		  *(pPort-1)&=~(1<<DQ);				  	
		  _delay_us(65);
		 }
		else
		 {
		  *(pPort)&=~(1<<DQ);			
		  *(pPort-1)|=1<<DQ;					  	
		  _delay_us(60);

		  *(pPort-1)&=~(1<<DQ);				  	
		  _delay_us(10);
		 }	 	
	 }	 
}

#endif